/* $Id: rc4.c,v 1.1 1998/07/21 11:03:27 levitte Exp $ */

#include "Pilot.h"
#include "ssh.h"
#include "rc4.h"

typedef struct {
    RC4_KEY rc4_key;
} Trc4_state;

void ssh_rc4_encrypt(unsigned char *in, unsigned char *out, long len,
    void *encryptstate_)
{
    Trc4_state *encryptstate = encryptstate_;

    RC4(encryptstate, len, in, out);
}

void ssh_rc4_decrypt(unsigned char *in, unsigned char *out, long len,
    void *decryptstate_)
{
    Trc4_state *decryptstate = decryptstate_;

    RC4(decryptstate, len, in, out);
}

void ssh_rc4_clean(ssh_state *state)
{
    MemPtrFree(state->encryptstate);
    MemPtrFree(state->decryptstate);
    state->encrypt = NULL;
    state->decrypt = NULL;
    state->cryptclean = NULL;
}

void *ssh_rc4_encryptstate(ssh_state *state, Erf erf, void *erfp)
{
    Trc4_state *encryptstate = MemPtrNew(sizeof(Trc4_state));
    if (!encryptstate) {
	ssh_fatal("Out of mem");
	return NULL;
    }
    RC4_set_key(encryptstate, 16, state->sesskey + 16);

    return encryptstate;
}

void *ssh_rc4_decryptstate(ssh_state *state, Erf erf, void *erfp)
{
    Trc4_state *decryptstate = MemPtrNew(sizeof(Trc4_state));
    if (!decryptstate) {
	ssh_fatal("Out of mem");
	return NULL;
    }
    RC4_set_key(decryptstate, 16, state->sesskey);

    return decryptstate;
}

/* Emacs local variables

Local variables:
eval: (set-c-style "BSD")
end:

*/
